


#include "msp430x44x.h"
#define LCD_DIV_64	    0x08
#define DAC_SYNC_BIT        0x80

void InitializeHardware( void );
void DAC_Init (void);
void Command_Execute_OutDAC0( char* pszCmdBuffer, int nBufferSize );
void Command_Execute_OutDAC1( char* pszCmdBuffer, int nBufferSize );
void Command_Execute_OutDAC2( char* pszCmdBuffer, int nBufferSize );
void Command_Execute_OutDAC3( char* pszCmdBuffer, int nBufferSize );
void Command_Execute_OutDAC4( char* pszCmdBuffer, int nBufferSize );
void Command_Execute_OutDAC5( char* pszCmdBuffer, int nBufferSize );
void Command_Execute_OutDAC6( char* pszCmdBuffer, int nBufferSize );
void Command_Execute_OutDAC7( char* pszCmdBuffer, int nBufferSize );
void Command_Execute_OutDAC8( char* pszCmdBuffer, int nBufferSize );
void Command_Execute_OutDAC9( char* pszCmdBuffer, int nBufferSize );
unsigned int OutDAC( int nValue );
unsigned int ExecuteSPI( unsigned int nArg );


void main( void )
{
    WDTCTL = WDTPW + WDTHOLD;             // Stop WDT

	InitializeHardware();
	DAC_Init();

	_EINT();    // Enable interrupts

    while(1)
    {
        OutDAC(0x0000);
        OutDAC(0x01C7);
        OutDAC(0x038E);
        OutDAC(0x0555);
        OutDAC(0x071C);
        OutDAC(0x08E3);
	OutDAC(0xAAA);
	OutDAC(0x0C71);
	OutDAC(0x0E38);
	OutDAC(0x0FFF);
	OutDAC(0x0E38);
	OutDAC(0x0C71);	
	OutDAC(0xAAA);
	OutDAC(0x08E3);
	OutDAC(0x071C);
	OutDAC(0x0555);
	OutDAC(0x038E);
	OutDAC(0x01C7);
    }
}

void DAC_Init( void )
{
	//*********** USART0 initialization for SPI communications ***********
	ME1 |= USPIE0;					// Enable USART0 SPI mode
	UCTL0 = CHAR+SYNC+MM;			// 8-bit SPI Master **SWRST** see page 13-16 TI slau049b.pdf
	U0TCTL = CKPL+SSEL1+SSEL0+STC;	// SelectSMCLK and 3-pin SPI select??
	UBR00 = 0x04;					// UCLK/2
	UBR10 = 0x00;					// 0
	UMCTL0 = 0x00;                  // no modulation  
										  
	//  IE2 |= URXIE1;              // Enable USART1 RX interrupt

	// Setup P3 for SPI0 operation
	P3SEL |= 0x0E;		// P3.1-3 SPI option select
	P3DIR |= 0x01;		// P3.0 output direction
	P3OUT |= 0x01;		// CS high
}

unsigned int OutDAC( int nValue )
{

	P2OUT &= ~0x80;		  //SYNC LOW FOR DAC
	ExecuteSPI( nValue>>8 );
	ExecuteSPI( nValue & 0xFF );
	P2OUT |= 0x80;          //SYNC LOW FOR DAC

	return 0;		
}

unsigned int ExecuteSPI( unsigned int nArg )
{	unsigned int nResult;

	while ((IFG1 & UTXIFG0) == 0);		// USART0 TX buffer ready?

    IFG1 &= ~URXIFG0;					// Clear Rx flag

	// Exchange byte
	TXBUF0 = nArg & 0xFF;
	while ((IFG1 & UTXIFG0) == 0);
	while ((IFG1 & URXIFG0) == 0);
	nResult = RXBUF0;
	
	return nResult;			
}

void InitializeHardware( void )
{
	FLL_CTL0 |= XCAP18PF;       // Set load capacitance for xtal// Setup port functions
	
	P1SEL = 0x32;		// Output P1.1 (MCLK), P1.4 (SMCLK), P1.5 (ACLK)
	P1DIR = 0x33;		 
	P1OUT = 0xFF;		 

	P2SEL = 0x00;		// Output P2.0 (DAC_SYNC)
	P2DIR = 0x80;		 
	P2OUT = 0x80;	
	
        P4SEL = 0xFC;
	  
	P5SEL = 0xFF;
	
	// Setup Basic Timer for LCD operation
	BTCTL = (LCD_DIV_64+0x23);
	
	// Setup LCD
	LCDCTL = (LCDSG0_7|LCD4MUX|LCDON);
	
	// Setup LCD data, turn all segments on
	LCDM1 = 0xFF;	// S1:S0	
	LCDM2 = 0xFF;	// S3:S2
	LCDM3 = 0xFF;	// S5:S4
	LCDM4 = 0xFF;	// S7:S6
	LCDM5 = 0xFF;	// S9:S8
	LCDM6 = 0xFF;	// S11:S10
	LCDM7 = 0xFF;	// S13:S12
	LCDM8 = 0xFF;	// S15:S14
	LCDM9 = 0xFF;	// S17:S16
	LCDM10 = 0xFF;	// S19:S18
	LCDM11 = 0xFF;	// S21:S20
	LCDM12 = 0xFF;	// S23:S22
	LCDM13 = 0xFF;	// S25:S24
	LCDM14 = 0xFF;	// S27:S26
	LCDM15 = 0xFF;	// S29:S28
	LCDM16 = 0xFF;	// S31:S30
	LCDM17 = 0xFF;	// S33:S32
	LCDM18 = 0xFF;	// S35:S34
	LCDM19 = 0xFF;	// S37:S36
	LCDM20 = 0xFF;	// S39:S38
}

